package LudumDare23;

import com.ixee.GraphIX.glEEngine;
import com.ixee.datastruct.Coordinate;

public abstract class Entity{
	public static final int OWNER_PLAYER = 0;
	public static final int OWNER_NONE = -1;
	public static final int OWNER_ENEMY = 1;


	protected GameTime reference;
	protected Planet parent;
	protected boolean alive = true;
	protected double angle;
	protected double orientation;
	protected double altitude;
	protected int owner;
	protected int height;
	protected int width;

	protected String ambientSound = "";

	public int getOwner(){
		return owner;
	}
	public abstract void update();
	public GameTime getClock(){
		return reference;
	}
	public Coordinate getPosition(){
		//hurr
		//Parent position + altitude*(cos(orientation), sin(orientation)
		return parent.getPosition().add(new Coordinate(altitude*Math.cos(orientation), altitude*Math.sin(orientation)));
	}
	public void setPosition(double ang, double alt){
		angle = ang;
		altitude = alt;
	}
	public double getAngle(){						//Get angle offset from 0 of whatever this is with respect to the center of its local universe. For resources/planes, it's the planet. For planets, it's the center of the universe.
		return angle;
	}
	public GameTime getReferenceTime(){
		return reference;
	}
	public double getRotation(){
		return orientation;
	}
	public double getAltitude(){
		return altitude;
	}
	public abstract void draw(glEEngine e);
	public void putInPlanet(Planet p){
		if(parent!= null){
			parent.remove(this);
		}
		parent = p;
	}
	public String getAmbientSound(){
		return ambientSound;
	}
	public Planet parent(){
		return parent;
	}
	public boolean alive(){
		return alive;
	}
	public abstract boolean hookshotting();
	public abstract int height();
	public abstract int width();

	public abstract void collide(Entity e);
}