package LudumDare23;

import com.ixee.GraphIX.*;
import com.ixee.datastruct.*;
import com.ixee.io.*;
import LudumDare23.Planes.*;
import LudumDare23.Menus.*;
import java.awt.*;
import java.util.*;
import paulscode.sound.libraries.LibraryLWJGLOpenAL;
import paulscode.sound.SoundSystem;
import paulscode.sound.SoundSystemException;
import paulscode.sound.SoundSystemConfig;
import paulscode.sound.codecs.CodecWav;
import java.net.URL;
import java.net.MalformedURLException;
import java.io.File;

public class Game{
	public static boolean soundEnabled = false;
	public static SoundSystem sounds;
	public static char KEY_ASCEND = 'w';
	public static char KEY_DESCEND = 's';
	public static char KEY_ACCELERATE = 'd';
	public static char KEY_DECELERATE = 'a';
	public static char KEY_HOOKSHOT = 'f';
	public static char KEY_PLANE_CHANGE = 'c';

	static GIXEngine engine;
	static HashMap<String, glEImage> loadedImages;
	static HashMap<String, glEAnim> loadedAnimations;
	static LinkedList<Entity> entitiesToDraw;

	public static int playerMaxAltLevel = 1;
	public static int playerMaxVelLevel = 1;
	public static int playerMaxAccLevel = 1;
	public static int playerMinVelLevel = 1;
	public static int playerAscendLevel = 1;
	public static int playerActionLevel = 1;

	public static int numDeaths = 0;
	public static int population = 0;

	public static int numPlanets = 20;

	public static boolean won = false;

	/*
		 Consider a temp linkedlist thing that each entity is a part of. That way we can quickly remove entities arbitrarially from the world.

	*/

	public static MenuIngame ingameMenu;

	static ArrayList<Planet> worldlyThings;

	static PlaneStarter plane;

	public static boolean escClose = false;
	static boolean paused = true;
	static boolean running = false;
	static boolean braceForNotRunning = false;

	public static Plane playerPlane = null;

	static GameTime gametime;

	static String gameWindowName = "First Import";
	public static final String assets = "./Assets/";
	static int resX = 800;
	static int resY = 575;

	public static GameCamera camera;

	static Planet respawnLoc;
	static Planet oldPlayerPlanet;

	public static void main(String[] args){
		try{
			SoundSystemConfig.addLibrary(LibraryLWJGLOpenAL.class);
			SoundSystemConfig.setCodec("wav", CodecWav.class);
			soundEnabled = true;
		}catch(SoundSystemException e){
			soundEnabled = false;
			stdio.debugAndLog("Could not start sound. Saaaad");
		}
		sounds = new SoundSystem();
		if(soundEnabled){
			loadSounds(TextLoader.loadFile(assets+"soundList.txt"));
		}
		sounds.setLooping("BGM", true);
		playSound("BGM");
		sounds.setLooping("Propeller", true);
		sounds.setLooping("MissileAmbient", true);


		gametime = new GameTime(0);
		engine = new GIXEngine(gameWindowName, resX, resY);
		engine.addMenu(new MenuStart(engine.menus()));
		entitiesToDraw = new LinkedList<Entity>();
		loadedImages = new HashMap<String, glEImage>();
		loadedAnimations = new HashMap<String, glEAnim>();
		worldlyThings = new ArrayList<Planet>();

		camera = new GameCamera(1, new Coordinate(0,0), 25);

		glEEngine graphics = engine.graphics();
		graphics.loadFont(assets+"Fonts/defaultfont.gixf");

		running = true;

		String[] resources = TextLoader.loadFile(assets+"resourceList.txt");

		loadResources(resources);

/*
		loadArchive("PlaneAirCarrier");
		loadArchive("StarterActiveAnim");
		loadArchive("PlaneStarter");
		loadArchive("Missile");
		loadArchive("MiningAnim");
		loadArchive("PlaneMining");
		loadArchive("PlaneXB31");


		glEImage hookshotimg = engine.loadImage(ImageLoader.loadFile(assets+"Images/Hookshot.png"));
		loadedImages.put("Hookshot",hookshotimg);
		glEImage colony = engine.loadImage(ImageLoader.loadFile(assets+"Images/Colony.png"));
		loadedImages.put("Colony", colony);
*/
		Plane p = new PlaneStarter();
		//p.setAnim(loadedAnimations.get(p.baseImage()));
		//p.setActiveAnim(loadedAnimations.get(p.activeAnimName()));

		generateWorlds(numPlanets);

		worldlyThings.set(0, new Planet(gametime));
		respawnLoc = worldlyThings.get(0);
		oldPlayerPlanet = worldlyThings.get(0);

		Game.givePlane(new PlaneStarter());

		//playerPlane = new PlaneMining();

		//playerPlane.setAnim(loadedAnimations.get(playerPlane.baseImage()));
		//playerPlane.setActiveAnim(loadedAnimations.get(playerPlane.activeAnimName()));
		//playerPlane.setLoc(new Coordinate(-200, 200));
		//worldlyThings.get(0).setVelocity(new Coordinate(0.1, 0));

		//worldlyThings.get(1).setVelocity(new Coordinate(-1, -1));
		//worldlyThings.get(1).setPosition(new Coordinate(300, 200));
		//worldlyThings.get(1).give(p);

		//worldlyThings.get(0).give(new Missile(playerPlane));

		//paused = false;
		long lastfps = System.currentTimeMillis();
		int frames = 0;
		while(running){
			long timeStart = System.nanoTime();
			if(!braceForNotRunning){
				update();
				engine.graphics().fillRect(new Coordinate(-(resX+10)/2, -(resY+10)/2), new Coordinate((resX+10)/2, (resY+10)/2), new Color(152, 227, 241));
				draw(engine.graphics());		//Draw the stuff relevant to this game.
				engine.renderMenus();
				engine.update();
				if(engine.closeRequested()||escClose){
					braceForNotRunning = true;
				}
			}else{
				//Are you really sure you want to quit? Defaults to YEP.
				running = false;
				braceForNotRunning = false;
			}
			try{
				Thread.sleep(10);
			}catch(InterruptedException ioe){
			}

			if(!paused){
				timeStart = System.nanoTime()-timeStart;
				gametime.setTime(gametime.time()+timeStart);
			}
			if(System.currentTimeMillis()-lastfps > 2000){
			//	worldlyThings.get(0).give(new Missile(playerPlane));

				System.out.println("FPS: "+frames/2);
				lastfps = System.currentTimeMillis();
				frames = 0;
			}
			if(playerPlane.alive() == false){
				Game.playSound("Died");
				numDeaths++;
				Game.givePlane(new PlaneStarter());
			}else{
				if(oldPlayerPlanet != playerPlane.parent()){
					respawnLoc = oldPlayerPlanet;
					oldPlayerPlanet = playerPlane.parent();
				}
			}
			if(numPlanets*10 == population){	//10 sections per planet
				won = true;
			}
			frames++;
			camera.offerSample(playerPlane.getPosition());
		}
		sounds.cleanup();
	}
	public static void loadResources(String[] resources){
		for(int i=0;i<resources.length;i++){
			String[] parts = resources[i].split(",");
			if(parts.length == 3){
				if(parts[0].equals("a")){
					try{
						glEAnimArchive animArch = new glEAnimArchive(assets+parts[2]);
						loadedAnimations.put(parts[1], engine.graphics().load(animArch));
						glEAnim anim = loadedAnimations.get(parts[1]);
						anim.setLoops(-1);
					}catch(Exception e){
						stdio.debugAndLog("In attempt to load archive "+parts[1]+", something bad happened and it's now ignored. Error follows in prompt.");
						e.printStackTrace();
					}
				}else if(parts[0].equals("i")){
					glEImage colony = engine.loadImage(ImageLoader.loadFile(assets+parts[2]));
					loadedImages.put(parts[1], colony);
					//load it as an image
				}else{
					stdio.debugAndLog("Invalid line in resourcelist.txt, unknown asset identifier: "+i);
				}
			}else{
				stdio.debugAndLog("invalid line in resourcelist.txt, not enough parts: "+i);
			}
		}
	}
	public static void generateWorlds(int numWorlds){
		Random r = new Random();
		for(int i=0;i<numWorlds;i++){
			worldlyThings.add(new Planet(gametime));
			if(i>0){
				int numPlanes = r.nextInt(2)+1;
				worldlyThings.get(i).setPosition(new Coordinate(r.nextDouble()*3000-1500, r.nextDouble()*3000-1500));
				for(int j=0;j<numPlanes;j++){
					int type = r.nextInt(5);
					Plane toAdd = null;
					switch(type){
						case 0:
							toAdd = new PlaneStarter();
							break;
						case 1:
							toAdd = new PlaneAirCarrier();
							break;
						case 2:
							toAdd = new PlaneCombat();
							break;
						case 3:
							toAdd = new PlaneMining();
							break;
						case 4:
							toAdd = new PlaneXB31();
							break;
					}
					if(toAdd != null){
						toAdd.pushAction(Plane.ACTIVE);
						toAdd.setOrientation(r.nextDouble()*Math.PI*2);
						toAdd.setAltitude((r.nextDouble()*(toAdd.getMaxAltitude()-toAdd.getMinAltitude())+toAdd.getMinAltitude())*worldlyThings.get(i).atmospheresize());
						worldlyThings.get(i).give(toAdd);
					}
				}
			}
		}
	}
	public static void update(){
		for(int i=0;i<worldlyThings.size();i++){
			worldlyThings.get(i).update();
		}
	}
	public static void draw(glEEngine e){
		for(int i=0;i<worldlyThings.size();i++){
			worldlyThings.get(i).draw(e);
		}
		while(entitiesToDraw.size()>0){
			entitiesToDraw.pollFirst().draw(e);
		}
		//playerPlane.draw(e);
	}
	public static void givePlane(Plane p){
		if(playerPlane != null){
			stopSound(playerPlane.getAmbientSound());
		}
		playerPlane = p;
		playSound(p.getAmbientSound());
		respawnLoc.give(playerPlane);
		if(ingameMenu != null){
			ingameMenu.sendText("New plane!");
		}
	}
	public static Plane playerPlane(){
		return playerPlane;
	}
	public static void setPause(boolean p){
		paused = p;
	}
	public static void doAction(int action){
		playerPlane.pushAction(action);
	}
	public static void close(){
		braceForNotRunning = true;
	}
	public static glEEngine graphics(){
		return engine.graphics();
	}
	public static glEImage getImage(String imgname){
		return loadedImages.get(imgname);
	}
	public static glEAnim getAnim(String aniname){
		return loadedAnimations.get(aniname);
	}
	public static Planet hookshotDest(Plane p){
		ArrayList<Planet> possiblePlanets = new ArrayList<Planet>(worldlyThings.size());
		Coordinate planeLoc = p.getPosition();

		double hookshotDist = Hookshot.maxDist*Hookshot.maxDist;

		double planeAngle = p.getLongitude()-Math.PI/2;

		Planet returnable = null;

		for(int i=0;i<worldlyThings.size();i++){
			if(worldlyThings.get(i) != p.parent() && pythag(worldlyThings.get(i).getPosition().sub(planeLoc)) <= hookshotDist){
				possiblePlanets.add(worldlyThings.get(i));
			}
		}
		possiblePlanets.trimToSize();
		for(int i=0;i<possiblePlanets.size();i++){
			Coordinate delta = possiblePlanets.get(i).getPosition().sub(planeLoc);
			double dist = Math.sqrt(pythag(delta));
			double cartesianAngle = Math.atan2(delta.getY(), delta.getX());

			//System.out.println("Cartesian angle to planet "+cartesianAngle+", distance is "+dist);
			if(Math.abs(cartesianAngle-planeAngle) < Math.atan2(possiblePlanets.get(i).groundradius(), dist)){
				if(returnable == null || dist < pythag(returnable.getPosition().sub(planeLoc))){
					returnable = possiblePlanets.get(i);
				}
			}
		}
		//System.out.println("In the end, the dest planet is... "+returnable);
		return returnable;
	}
	public static double pythag(Coordinate c){
		return c.getX()*c.getX()+c.getY()*c.getY();
	}
	public static void loadArchive(String archiveName){
		try{
			glEAnimArchive animArch = new glEAnimArchive("./LudumDare23/Assets/Animations/"+archiveName+".gixani");
			loadedAnimations.put(archiveName, engine.graphics().load(animArch));
			glEAnim anim = loadedAnimations.get(archiveName);
			anim.setLoops(-1);
			//planeCarrierAnim.setMsPerFrame(250);
		}catch(Exception e){
			stdio.debugAndLog("In attempt to load archive "+archiveName+", something bad happened and it's now ignored. Error follows in prompt.");
			e.printStackTrace();
		}
	}
	public static void loadSounds(String[] soundList){
		for(int i=0;i<soundList.length;i++){
			String[] soundParts = soundList[i].split(",");
			if(soundParts.length == 2){
				//sounds.newSource(false, "BGM", "C:/Java/LudumDare23/Assets/Sounds/ld23bgm.wav", true, 0f, 0f, 0f, SoundSystemConfig.ATTENUATION_ROLLOFF, SoundSystemConfig.getDefaultRolloff());
				try{
					sounds.newSource(false, soundParts[0], new URL("file:"+assets+"Sounds/"+soundParts[1]), assets+"Sounds/"+soundParts[1], false, 0f, 0f, -10f, SoundSystemConfig.ATTENUATION_ROLLOFF, SoundSystemConfig.getDefaultRolloff());
				}catch(MalformedURLException mue){}
			}
		}
	}
	public static void playSound(String sound){
		sounds.play(sound);
	}
	public static void stopSound(String sound){
		sounds.stop(sound);
	}
	public static void draw(Entity e){
		entitiesToDraw.push(e);
	}
	public static void givePlayer(Resource r){

	}
	public static GameTime clock(){
		return gametime;
	}
}