package LudumDare23;

import com.ixee.GraphIX.*;
import com.ixee.io.*;
import com.ixee.datastruct.*;
import LudumDare23.Game;

public class Hookshot{
	public static double maxDist = 800;
	Plane plane;
	Planet dest;

	double dragspeed;

	long starttime;

	double expectedtime;

	GameTime reference;

	glEImage drawImage;

	Coordinate planeStartPos;



	public Hookshot(Plane p, Planet d){
		plane = p;
		planeStartPos = p.getPosition();
		dest = d;

		dragspeed = 80;

		Coordinate delta = dest.getPosition().sub(planeStartPos);
		double dist = Math.sqrt(delta.getX()*delta.getX()+delta.getY()*delta.getY())-dest.groundradius();

		expectedtime = dist/dragspeed*1000;

		reference = p.getReferenceTime();

		starttime = reference.time();

		setImage(Game.getImage("Hookshot"));

	}
	public void setImage(glEImage img){
		drawImage = img;
	}
	public void draw(glEEngine e){
		/*
			DO SOME MAGIC, ALSO PANIC.
		*/
		if(drawImage != null){
			Coordinate imageloc = Game.camera.getlocation().sub(plane.getPosition());
			Coordinate delta = dest.getPosition().sub(plane.getPosition());
			double dist = Math.sqrt(delta.getX()*delta.getX()+delta.getY()*delta.getY());
			double angle = Math.atan2(delta.getY(), delta.getX());

			double iterationdist = drawImage.getSize().getX();

			Coordinate iterationAmount = new Coordinate(iterationdist*Math.cos(angle), iterationdist*Math.sin(angle));

			for(double current = iterationdist/2;current<dist+0.01;current+=iterationdist){
				e.drawImage(drawImage, imageloc, angle/2);
				imageloc = imageloc.add(iterationAmount);
			}

		}else{
			stdio.debugAndLog(this, "Warning, hookshot has no image associated with it! Something's wrong there.");
		}

	}
	public Coordinate myposition(){
		Coordinate delta = dest.getPosition().sub(planeStartPos);
		double dist = Math.sqrt(Game.pythag(delta));
		double time = (dist-dest.groundradius())/dragspeed*1000;

		Coordinate returnable = planeStartPos.add(delta.mult(reference.delta(starttime)/time).mult((dist-dest.groundradius())/dist));
		return returnable;
	}
	public double timeleft(){

		Coordinate delta = dest.getPosition().sub(planeStartPos);
		double dist = Math.sqrt(delta.getX()*delta.getX()+delta.getY()*delta.getY())-dest.groundradius();

		expectedtime = dist/dragspeed*1000;

		//System.out.println(expectedtime - reference.delta(starttime));
		return expectedtime - reference.delta(starttime);
	}
	public Planet dest(){
		return dest;
	}
}