package LudumDare23.Menus;

import com.ixee.ui.*;
import com.ixee.ui.ogl.*;
import com.ixee.io.*;
import java.util.*;
import com.ixee.GraphIX.*;
import com.ixee.datastruct.Coordinate;
import LudumDare23.*;
import java.awt.*;
import LudumDare23.Planes.*;

public class MenuChangePlane extends MenuOGL{
	UIImageButton starter;
	UIImageButton combat;
	UIImageButton mining;
	UIImageButton aircarrier;
	UIImageButton xb31;

	UIButton exit;
	UIButton confirm;

	Plane chosen;

	UIText chooseyourplaneprompt;

	static final int EXIT = 0;
	static final int CHOOSE = 1;
	static final int STARTER = 2;
	static final int MINING = 3;
	static final int COMBAT = 4;
	static final int AIRCARRIER = 5;
	static final int XB31 = 6;

	public MenuChangePlane(MenuStackOGL m){
		super(m);
		mode = -1;
		top = true;

		int population = Game.population;

		Coordinate engineSize = Game.graphics().getSize();

		glEImage startimg = Game.getImage("StarterFancy");
		glEImage combatimg = Game.getImage("CombatFancy");
		glEImage miningimg = Game.getImage("MiningFancy");
		glEImage aircarrierimg = Game.getImage("AirCarrierFancy");
		glEImage xb31img = Game.getImage("XB31Fancy");

		starter = new UIImageButton(new Coordinate(-startimg.getSize().getX()*1.5, startimg.getSize().getY()*0.75), startimg, STARTER);
		combat = new UIImageButton(new Coordinate(0, combatimg.getSize().getY()*0.75), combatimg, COMBAT);
		mining = new UIImageButton(new Coordinate(miningimg.getSize().getX()*1.5, miningimg.getSize().getY()*0.75), miningimg, MINING);
		aircarrier = new UIImageButton(new Coordinate(-aircarrierimg.getSize().getX()*0.75, -aircarrierimg.getSize().getY()*0.75), aircarrierimg, AIRCARRIER);
		xb31 = new UIImageButton(new Coordinate(xb31img.getSize().getX()*0.75, -xb31img.getSize().getY()*0.75), xb31img, XB31);

		chooseyourplaneprompt = new UIText(new Coordinate(0, Game.graphics().getSize().getY()/2), "Choose your plane!", UIText.V_BOTTOM, Color.BLACK);

		exit = new UIButton(new Coordinate(-75, -engineSize.getY()/2+32), new Coordinate(60, 20), EXIT, "Cancel");
		confirm = new UIButton(new Coordinate(75, -engineSize.getY()/2+32), new Coordinate(60, 20), CHOOSE, "Confirm");

		elements.add(exit);
		activeElements.add(exit);
		elements.add(confirm);
		activeElements.add(confirm);

		elements.add(chooseyourplaneprompt);

		activeElements.add(starter);
		if(population >= 2){
			activeElements.add(combat);
		}else{
			combat.setImage(Game.getImage("lock0"));
		}
		if(population >= 4){
			activeElements.add(mining);
		}else{
			mining.setImage(Game.getImage("lock1"));
		}
		if(population >= 8){
			activeElements.add(aircarrier);
		}else{
			aircarrier.setImage(Game.getImage("lock2"));
		}
		if(population >= 16){
			activeElements.add(xb31);
		}else{
			xb31.setImage(Game.getImage("lock3"));
		}

		elements.add(starter);
		elements.add(combat);
		elements.add(mining);
		elements.add(aircarrier);
		elements.add(xb31);

	}
	public void doStuff(){
		switch(mode){
			case EXIT:
				parent.removeMenu(this);
				Game.setPause(false);
				break;
			case CHOOSE:
				if(chosen != null){
					Game.givePlane(chosen);
				}
				parent.removeMenu(this);
				Game.setPause(false);
				break;
			case STARTER:
				chosen = new PlaneStarter();
				Game.playSound("PickColonizer");
				break;
			case MINING:
				chosen = new PlaneMining();
				Game.playSound("PickMining");
				break;
			case COMBAT:
				chosen = new PlaneCombat();
				Game.playSound("PickCombat");
				//no combat plane yet
				break;
			case AIRCARRIER:
				chosen = new PlaneAirCarrier();
				Game.playSound("PickAirCarrier");
				//No aircarriers yet
				break;
			case XB31:
				chosen = new PlaneXB31();
				Game.playSound("PickXB31");
				break;
		}
		mode = -1;
	}
}