package LudumDare23.Menus;

import com.ixee.ui.*;
import com.ixee.ui.ogl.*;
import com.ixee.io.*;
import java.util.*;
import com.ixee.datastruct.Coordinate;
import LudumDare23.*;
import java.awt.Color;
import com.ixee.GraphIX.*;
import java.awt.image.BufferedImage;

public class MenuIngame extends MenuOGL{
	UIImage stats;
	UIImage info;
	UIImage console;
	UIImage button;
	UIImage directions;
	UIText velocity;
	UIText altitude;
	//UIText health;
	UIText tech;
	UIText planeType;
	UIText longitude;
	UIText recentEvent;

	UIText levels;
	UIText alt;
	UIText vel;
	UIText accel;
	UIText pitch;
	UIText special;

	UIText deathCounter;
	UIText population;

	UIButton map;
	UIButton research;
	UIButton changePlane;

	UIText winText;

	UIPoly healthBackground;
	UIPoly healthBar;
	UIText healthValue;

	double health = 1.0;

	double healthWidth = 40;
	double healthHeight = 8;

	Coordinate[] healthBounds = new Coordinate[4];

	Coordinate infoLoc;

	Color consoleTextColor = new Color(136, 0, 21);

	public MenuIngame(MenuStackOGL m){
		super(m);

		glEEngine graphics = Game.graphics();

		glEImage consoleimg = Game.getImage("centerconsole");

		glEImage infoimg = Game.getImage("infopane");

		glEImage statsimg = Game.getImage("statspane");

		glEImage directionsimg = Game.getImage("directpane");

		winText = new UIText(new Coordinate(Game.graphics().getSize().getX()/2, 0), Integer.toString(Game.population)+"/"+Integer.toString(Game.numPlanets*10)+" colonies!", UIText.H_RIGHT, consoleTextColor);
		elements.add(winText);
		healthValue = new UIText(new Coordinate(Game.graphics().getSize().getX()/2, -20), "Health: "+Integer.toString(Game.playerPlane.life())+"/"+Integer.toString(Game.playerPlane.maxlife), UIText.H_RIGHT, consoleTextColor);
		elements.add(healthValue);

		health = (1.0*Game.playerPlane.life())/Game.playerPlane.maxlife;

		healthBounds[0] = new Coordinate(20-health*healthWidth, healthHeight/2);
		healthBounds[1] = new Coordinate(20-health*healthWidth, -healthHeight/2);
		healthBounds[2] = new Coordinate(20, -healthHeight/2);
		healthBounds[3] = new Coordinate(20, healthHeight/2);

		healthBackground = new UIPoly(new Coordinate(Game.graphics().getSize().getX()/2-40, -40), healthBounds, new Color(169, 14, 21));
		healthBackground.setFill(true);
		healthBar = new UIPoly(new Coordinate(Game.graphics().getSize().getX()/2-40, -40), healthBounds, new Color(16, 114, 219));
		healthBar.setFill(true);

		elements.add(healthBackground);
		elements.add(healthBar);

		Coordinate statsLoc = null;
		Coordinate statsSize;

		infoLoc = null;
		Coordinate infoSize = new Coordinate(0,0);

		Coordinate screenSize = graphics.getSize();
		Coordinate consoleLoc = null;
		Coordinate consoleSize = null;

		if(consoleimg != null){
			//glEImage consoleimg = graphics.loadImage(consolebmp);
			consoleLoc = new Coordinate(0, -screenSize.getY()/2 + consoleimg.getSize().getY()/2);
			consoleSize = consoleimg.getSize();
			console = new UIImage(consoleLoc, consoleimg);
			elements.add(console);
		}else{
		}
		if(infoimg != null){
			infoLoc = new Coordinate(-screenSize.getX()/2+infoimg.getSize().getX()/2, screenSize.getY()/2-infoimg.getSize().getY()/2);
			infoSize = infoimg.getSize();
			info = new UIImage(infoLoc, infoimg);
			elements.add(info);
		}
		if(statsimg != null){
			statsLoc = new Coordinate(-screenSize.getX()/2+infoSize.getX()+statsimg.getSize().getX()/2, screenSize.getY()/2-statsimg.getSize().getY()/2);
			statsSize = statsimg.getSize();
			stats = new UIImage(statsLoc, statsimg);
			elements.add(stats);
		}
		if(consoleLoc != null){
			velocity = new UIText(new Coordinate(37, -6).add(consoleLoc), "", (byte)0, consoleTextColor);
			altitude = new UIText(new Coordinate(37, 4).add(consoleLoc), "", (byte)0, consoleTextColor);
			longitude = new UIText(new Coordinate(37, -16).add(consoleLoc), "", (byte)0, consoleTextColor);

			elements.add(velocity);
			elements.add(altitude);
			elements.add(longitude);
		}
		recentEvent = new UIText(Game.graphics().getSize().mult(0.5), "Game Started!", UIText.B_RIGHT, Color.BLACK);

		if(infoLoc != null){
			Coordinate currentTextLoc = infoLoc.add(new Coordinate(30, 85));
			Coordinate offsetAmount = new Coordinate(0, -10);
			levels = new UIText(currentTextLoc, "0", UIText.H_LEFT, consoleTextColor);
			currentTextLoc = currentTextLoc.add(offsetAmount).add(offsetAmount);
			alt = new UIText(currentTextLoc, "0", UIText.H_LEFT, consoleTextColor);
			currentTextLoc = currentTextLoc.add(offsetAmount);
			vel = new UIText(currentTextLoc, "0", UIText.H_LEFT, consoleTextColor);
			currentTextLoc = currentTextLoc.add(offsetAmount);
			accel = new UIText(currentTextLoc, "0", UIText.H_LEFT, consoleTextColor);
			currentTextLoc = currentTextLoc.add(offsetAmount);
			pitch = new UIText(currentTextLoc, "0", UIText.H_LEFT, consoleTextColor);
			currentTextLoc = currentTextLoc.add(offsetAmount);
			special = new UIText(currentTextLoc, "0", UIText.H_LEFT, consoleTextColor);
			//currentTextLoc = currentTextLoc.add(offsetAmount);

			elements.add(levels);
			elements.add(alt);
			elements.add(vel);
			elements.add(accel);
			elements.add(pitch);
			elements.add(special);

		}
		if(statsLoc != null){
			deathCounter = new UIText(statsLoc.add(new Coordinate(-90, 13)), Integer.toString(Game.numDeaths), UIText.H_RIGHT, consoleTextColor);
			elements.add(deathCounter);
			population = new UIText(statsLoc.add(new Coordinate(80, 1)), Integer.toString(0), UIText.H_RIGHT, consoleTextColor);
			elements.add(population);
		}else{
			deathCounter = null;
		}
		if(directionsimg != null){
			Coordinate c = graphics.getSize().mult(0.5).sub(directionsimg.getSize().mult(0.5));
			c.setY(-c.getY());
			directions = new UIImage(c, directionsimg);
			elements.add(directions);
		}

		elements.add(recentEvent);
	}

	public boolean check(CursorInfo curs, KeyboardInfo key){
		if(key.hasNext() && activeText == null){
			//char c = key.keyAsChar();
			if(key.isKeyPressed(Game.KEY_ASCEND)){
				Game.doAction(Plane.ACTION_ASCENDING);
			}else if(key.isKeyPressed(Game.KEY_DESCEND)){
				Game.doAction(Plane.ACTION_DESCENDING);
			}else if(key.isKeyPressed(Game.KEY_ACCELERATE)){
				Game.doAction(Plane.ACTION_ACCELERATING);
			}else if(key.isKeyPressed(Game.KEY_DECELERATE)){
				Game.doAction(Plane.ACTION_DECELERATING);
			}else if(key.isPressed(KeyboardInfo.SPACE)){
				Game.doAction(Plane.ACTIVE);
			}else if(key.isKeyPressed(Game.KEY_HOOKSHOT)){
				Game.doAction(Plane.HOOKSHOT);
			}else if(key.isKeyPressed(Game.KEY_PLANE_CHANGE)){
				parent.addMenu(new MenuChangePlane(parent));
				Game.setPause(true);
			}else if(key.isPressed(KeyboardInfo.ESCAPE)){
				Game.escClose = true;
			}
		}
		return super.check(curs, key);
	}
	public void sendText(String s){
		recentEvent.setText(s);
	}
	public void draw(glEEngine e){
		health = (1.0*Game.playerPlane.life())/Game.playerPlane.maxlife;

		healthBounds[0] = new Coordinate(20-health*healthWidth, healthHeight/2);
		healthBounds[1] = new Coordinate(20-health*healthWidth, -healthHeight/2);

		healthBar.setCoords(healthBounds);

		Plane toDraw = Game.playerPlane;
		if(velocity != null && altitude!=null && longitude != null){				//Then the following things are defined and can be done
			velocity.setText(String.format("%d", Math.round(toDraw.getVelocity())));
			altitude.setText(String.format("%d", Math.round(toDraw.getAltitude())));
			longitude.setText(String.format("%d", Math.round(Math.toDegrees(toDraw.getLongitude()))));
		}
		if(infoLoc != null){
			levels.setText(Integer.toString(Game.playerMaxAltLevel+Game.playerMaxVelLevel+Game.playerMaxAccLevel+Game.playerAscendLevel+Game.playerActionLevel));
			alt.setText(Integer.toString(Game.playerMaxAltLevel));
			vel.setText(Integer.toString(Game.playerMaxVelLevel));
			accel.setText(Integer.toString(Game.playerMaxAccLevel));
			pitch.setText(Integer.toString(Game.playerAscendLevel));
			special.setText(Integer.toString(Game.playerActionLevel));
		}
		if(deathCounter != null){
			deathCounter.setText(Integer.toString(Game.numDeaths));
			population.setText(Integer.toString(Game.population*10000));
		}
		if(Game.won){
			winText.setText("You win!!");
		}else{
			winText.setText(Integer.toString(Game.population)+"/"+Integer.toString(Game.numPlanets*10)+" colonies!");
		}
		healthValue.setText("Health: "+Integer.toString(Game.playerPlane.life())+"/"+Integer.toString(Game.playerPlane.maxlife));

		super.draw(e);
		// show the player ship's health
		/*
			Show the player ship's speed
			show the player ship's height
			show the player ship's technology
			show the player ship's upgrades
			allow the player to start the construction of buildings
			allow for non-destructive changing of ships
		*/
	}
}