package LudumDare23;

import com.ixee.GraphIX.*;
import com.ixee.datastruct.*;

public class Missile extends Plane{
	glEAnim currentAnim;

	long lastframechangetime;
	long lastupdatetime;

	float pitch;

	Plane target;

	String activeAnimName = "";
	String animName = "Missile";

	public Missile(Plane dest){
		currentVelocity = 80;
		acceleration = 70;
		minVelocity = 3;
		maxVelocity = 70;
		maxAltitude = 0.8;
		minAltitude = 0.4;
		ascendRate = 10;

		target = dest;
		reference = Game.clock();
		setAnim(Game.getAnim(baseImage()));
	}
	public void update(){
		if(target.parent() != this.parent() || target.alive() == false){
			alive = false;
		}
		double delta = reference.delta(lastupdatetime)/1000;
		pitch = 0;
		if(this.getAltitude() < target.getAltitude()-2){
			altitude = Math.min(parent.atmospheresize()*maxAltitude, Math.min(target.getAltitude(), altitude+delta*ascendRate));
			pitch = (float)Math.toRadians(15f);
		}else if(this.getAltitude() > target.getAltitude()+2){
			altitude = Math.max(parent.atmospheresize()*minAltitude, Math.max(target.getAltitude(), altitude-delta*ascendRate));
			pitch = (float)Math.toRadians(-15f);
		}
		orientation -= delta*currentVelocity/(altitude);
		if(orientation < -Math.PI){
			orientation += 2*Math.PI;
		}else if(orientation > Math.PI){
			orientation -= 2*Math.PI;
		}
		lastupdatetime = reference.time();

	}
	public boolean hookshotting(){
		return false;
	}
	public int width(){
		if(currentAnim != null){
			return currentAnim.current().getSize().intX();
		}else{
			return 0;
		}
	}
	public int height(){
		if(currentAnim != null){
			return currentAnim.current().getSize().intY();
		}else{
			return 0;
		}
	}
	public void draw(glEEngine e){
		if(reference.delta(lastframechangetime) > currentAnim.getMsPerFrame()){
			currentAnim.next();
			lastframechangetime = reference.time();
		}
		e.drawImage(currentAnim.current(), getPosition().sub(Game.camera.getlocation()), (orientation+pitch-Math.PI/2)/2);
	}
	public void collide(Entity e){
		if(e == target){
			//BOOM IT! BOOM IT!!
			System.out.println("Collision");
			target.dealDamage(1);
			target.testLife();
			alive = false;
		}
	}
	public String[] animationNames(){
		return new String[]{};
	}
	public String baseImage(){
		return animName;
	}
	public void pushAction(int i){
		//MISSILE DOES NOT GET TOLD WHAT TO DO, MISSILE ONLY KNOWS TO SMASH AND KILL AND DESTROY.
	}
	public void setAnim(glEAnim newAnim){
		currentAnim = newAnim.copy();
		currentAnim.setLoops(-1);
		currentAnim.setMsPerFrame(170);
	}
	public String activeAnimName(){
		return activeAnimName;
	}
	public void setActiveAnim(glEAnim anim){
		//Planes don't have an ~active~ animation
	}
}