package LudumDare23;

import com.ixee.datastruct.Coordinate;
import com.ixee.GraphIX.*;

public abstract class Plane extends Entity{
	public static final int ACTION_IDLING = -1;
	public static final int ACTION_ACCELERATING = 0;
	public static final int ACTION_DECELERATING = 1;
	public static final int ACTION_ASCENDING = 3;
	public static final int ACTION_DESCENDING = 4;
	public static final int ACTIVE = 5;
	public static final int HOOKSHOT = 6;

	protected int life = 1;
	public int maxlife = 1;
	protected double currentVelocity = 10;
	protected double acceleration = 5;
	protected double minVelocity = 3;
	protected double maxVelocity = 20;
	protected double maxAltitude = 0.8;
	protected double minAltitude = 0.4;
	protected double ascendRate = 0.5;

	public abstract String[] animationNames();
	public abstract String baseImage();
	public abstract void pushAction(int a);
	public abstract void setAnim(glEAnim e);
	public abstract String activeAnimName();
	public abstract void setActiveAnim(glEAnim e);

	public double getVelocity(){
		return currentVelocity;
	}
	public double getMinVelocity(){
		return minVelocity;
	}
	public double getMaxVelocity(){
		return maxVelocity;
	}
	public double getMaxAltitude(){
		return maxAltitude;
	}
	public double getMinAltitude(){
		return minAltitude;
	}
	public double getAscendRate(){
		return ascendRate;
	}
	public double getLongitude(){
		return orientation;
	}
	public void setOrientation(double angle){
		orientation = angle;
	}
	public void setAltitude(double alt){
		if((alt > minAltitude && alt < maxAltitude) || parent == null){
			altitude = alt;
		}else{
			altitude = parent.atmospheresize()*minAltitude;
		}
	}
	public void dealDamage(int damage){
		life = life-damage;
	}
	public int life(){
		return life;
	}
	public abstract boolean hookshotting();
	public void testLife(){
		if(life == 0){
			alive = false;
		}
	}
}