package com.ixee.GraphIX;

import com.ixee.datastruct.Coordinate;
import com.ixee.io.stdio;

public class GIXMath{
	double[] rootTable;//one day set this up to contain a table of precomputed square roots. Probably 1.0-50.0k or so. That's 4mb.
	double[][] trigtable; //a table of sin/cos for 0 to 360, 0.001 degree intervals. That makes for 360000*2 entries or roughly 5.76mb
	int trigPrecision = 1000; //number of entries between two given degrees.
	boolean init = false;

	public GIXMath(){
		initTrig();
		initRoot();
		init=true;
	}
	private void initTrig(){
//		stdio.println("Initializing GIXMath trig table");
//		stdio.println("Sin and cos for 0 to 360, precision of "+trigPrecision);
		int percentageGoal = 0;
		int percentageDetail = 5;
		int percentage = 0;
		trigtable = new double[360*trigPrecision][2];
		for(int i=0;i<360*trigPrecision;i++){
			trigtable[i][0] = Math.sin(Math.toRadians(i*360.0/trigPrecision));
			trigtable[i][1] = Math.cos(Math.toRadians(i*360.0/trigPrecision));
			percentage = (int)(i*100.0/(360*trigPrecision));
			//System.out.println(percentage);
			if((int)Math.round(percentage)==percentageGoal){
//				stdio.println(percentage+"% completed");
				percentageGoal += percentageDetail;
			}
		}
		stdio.println("Trig table generated.");
	}
	private void initRoot(){
	}
	public double cos(double d){
		double temp = reduceAngle(Math.toDegrees(d));
		int index = (int)Math.round(temp*trigPrecision);
		return trigtable[index][1];
	}
	public double sin(double d){
		double temp = reduceAngle(Math.toDegrees(d));
		int index = (int)Math.round(temp*trigPrecision);
		return trigtable[index][0];
	}
	public double reduceAngle(double d){
		while(d>=360){
			d-=360;
		}
		while(d<0){
			d+=360;
		}
		return d;
	}
	public static Coordinate toScreenSpace(Coordinate gameSpace, Coordinate cameraLoc){

		Coordinate correction = cameraLoc;
		double scaleFactor = 1/cameraLoc.getZ();
		Coordinate temp = new Coordinate(correction);
		temp = gameSpace.sub(temp);
		temp = new Coordinate(temp.getX()*scaleFactor, temp.getY()*scaleFactor, temp.getZ());

		return temp;
	}
}