package com.ixee.dataops;

import com.ixee.datastruct.Matrix;

public class MatrixOperations{
	public static Matrix transpose(Matrix m){
		Matrix returnable = new Matrix(m.width(), m.height());
		for(int i=0;i<m.height();i++){
			for(int j=0;j<m.width();j++){
				returnable.setElem(j, i, m.getElem(i, j));
			}
		}
		return returnable;
	}
	public static Matrix sum(Matrix m, Matrix n){
		Matrix returnable = new Matrix(m.height(), m.width());
		for(int i=0;i<m.height();i++){
			for(int j=0;j<m.width();i++){
				returnable.setElem(i, j, m.getElem(i, j)+n.getElem(i, j));
			}
		}
		return returnable;
	}
	public static Matrix sub(Matrix m, Matrix n){
		return mult(m, mult(n, -1));
	}
	public static Matrix mult(Matrix m, double n){
		Matrix returnable = new Matrix(m.height(), m.width());
		for(int i=0;i<m.height();i++){
			for(int j=0;j<m.width();j++){
				returnable.setElem(i, j, n*m.getElem(i, j));
			}
		}
		return returnable;
	}
	public static Matrix mult(Matrix m, Matrix n){
		Matrix returnable = new Matrix(m.height(), n.width());
		for(int i=0;i<returnable.height();i++){
			for(int j=0;j<returnable.width();j++){
				double accum = 0;
				for(int k=0;k<m.width();k++){
					accum += m.getElem(i, k)*n.getElem(k, j);
				}
				returnable.setElem(i, j, accum);
			}
		}
		return returnable;
	}
}