//exception for when a file is not loaded, but is requested. Particularly for the IOManager class.
package com.ixee.io;

import java.io.File;

public class FileNotLoadedException extends Exception{
	public FileNotLoadedException(){
		super("An asset was requested that an IOManager did not have loaded.");
	}
	public FileNotLoadedException(String f){
		super("The asset "+f+" was requested, but the IOManager did not have it loaded.");
	}
	public FileNotLoadedException(File f){
		super("The asset "+f.getName()+" was requested, but the IOManager did not have it loaded.");
	}
	public FileNotLoadedException(IOManager io){
		super("An asset was requested that type "+io.getType()+" IOManager "+io+" did not have loaded.");
	}
	public FileNotLoadedException(String f, IOManager io){
		super("The asset "+f+" was requested, but type "+io.getType()+" IOManager "+io+" did not have it loaded.");
	}
	public FileNotLoadedException(File f, IOManager io){
		super("The asset "+f.getName()+" was requested, but type "+io.getType()+" IOManager "+io+" did not have it loaded.");
	}
}