package com.ixee.io;

import javax.imageio.ImageIO;
import java.util.ArrayList;
import java.io.File;
import java.awt.Image;
import java.io.IOException;

public class IOManager{
	public static final int UserInput = 3;
	public static final int Images = 1;
	public static final int Sounds = 2;
	ArrayList<IODataStruct> files = new ArrayList<IODataStruct>();
	File documentationDirectory = null;
	int type=-1;

	public IOManager(int t, String dir){
		type = t;
		switch(type){
			case Images:
				documentationDirectory = new File(dir);
				analyzeFolder(documentationDirectory);
				break;
			case Sounds:
				//do stuff for sound reading and storage
			case UserInput:
				//do stuff for key reading
				//stuff here being setting the boolean[][] in Variables.java
				//to true when a key is pressed, and false when a key is released
				//and every time pushKeys() is called, flipping the int keySet in
				//Variables.java from 0 to 1 or 1 to 0

				//all attempts by the program to read keys will be by pulling
				//Variables.keyStates[keySet][intKeyNumber]
				break;
		}
	}
	//Fix this one at some point in the future so it accepts any file with
	//any extension specified in a String[] ext

	//also change it later so it doesn't store the whole directory path to
	//each item stored, just the relative directory.
	public void analyzeFolder(File f){
		if(f.isDirectory()){
			String[] folderContents = f.list();
			for(int i=0;i<folderContents.length;i++){
				File temp = new File(f, folderContents[i]);
				if(temp.isFile()){
					String itemPath = f.getPath() +"/"+ folderContents[i];
					if(temp.getName().contains(".bmp")||temp.getName().contains(".png")){
						try{
							Image im = ImageIO.read(new File(itemPath));
							files.add(new IODataStruct<Image>(itemPath, im));
						}catch(IOException e){System.out.println("[IOManager.analyzeFolder]: Something went wrong reading "+ itemPath);}
					}else{
						if(temp.getName().endsWith(".wav")){
							//try{

							//}catch(IOException e){System.out.println("[IOManager.analyzeFolder]: Something went wrong reading "+ itemPath);}
						}
					}
				}else{
					analyzeFolder(temp);
				}
			}
		}else{
			System.out.println("[IOManager.analyzeFolder]: Why didn't you give the IOManager a folder?");
			try{
				System.out.println(f.getCanonicalPath());
			}catch(IOException ioe){}
		}
	}
	public void printFiles(){
		for(int i=0;i<files.size();i++){
			System.out.println(files.get(i).getItemPath());
		}
	}
	public IODataStruct getFile(String name) throws FileNotLoadedException{
		boolean gotIt = false;
		int index = 0;
		while(!gotIt&&index<files.size()){
			IODataStruct temp = files.get(index);
			if(temp.getItemPath().contains(name)){
				gotIt = true;
			}else{
				index++;
			}
		}
		if(gotIt){
			return files.get(index);
		}else{
			System.out.println("FAILFAILFAILFAILFAILFAILFAILFAILFAILFAIL");
			System.out.println(name);
			try{
				System.out.println(documentationDirectory.getCanonicalPath());
			}catch(IOException ioe){
				ioe.printStackTrace();
			}
			throw new FileNotLoadedException();
		}
	}
	public <T> T getImage(String name){
		T returnable = null;
		try{
			returnable = (T)getFile(name).getContents();
		}catch(FileNotLoadedException fnle){
			fnle.printStackTrace();
		}
		return returnable;
	}
	public int getType(){
		return type;
	}
}
