/*
	This takes in a byte[] of some flavor and sets up a reading marker, with
	methods to request certain segments of the source byte[], which all increment the
	reading marker by appropriate amounts, throwing a crazy fit if the reading marker
	is attempted to be pushed past te end.
*/

package com.ixee.io;

public class MarkedInputStream{
	byte[] buffer;
	int marker = 0;

	public MarkedInputStream(byte[] array){
		buffer = array;
	}
	public byte get(){
		return get(1)[0];
	}
	public void skip(int n){
		if(marker+n > buffer.length){
			marker = buffer.length;
		}else{
			marker += n;
		}
	}
	public byte[] get(int bytes){
		byte[] returnable = new byte[0];
		if(marker+bytes > buffer.length){
			stdio.debug(this, "Request goes outside buffer, marker = "+marker+", request = "+bytes);
		}else{
			returnable = new byte[bytes];
			System.arraycopy(buffer, marker, returnable, 0 , bytes);
			marker += bytes;
		}
		return returnable;
	}
	public void reset(){
		marker = 0;
	}
	public int size(){
		return buffer.length;
	}
	public int remaining(){
		return buffer.length-marker;
	}
	public int markerPosition(){
		return marker;
	}
}