package com.ixee.io;

import java.io.File;
import java.io.FileReader;
import java.io.BufferedReader;
import java.io.FileOutputStream;

public class TextLoader{
	private TextLoader(){}
	public static String[] loadFile(String fileName){
		String[] returnable = new String[0];
		File f = new File(fileName);
		if(!f.exists()){
			stdio.debug(new TextLoader(), "File to load does not exist.");
		}else{
			try{
				BufferedReader br = new BufferedReader(new FileReader(f));
				String temp = "";
				temp = br.readLine();
				while(temp != null){
					if(!temp.startsWith("#")){
						String[] returnable2 = new String[returnable.length+1];
						System.arraycopy(returnable, 0, returnable2, 0, returnable.length);
						returnable2[returnable.length] = temp;
						returnable = returnable2;
					}else{
						if(stdio.verbose()){
							stdio.debug(new TextLoader(), "ignoring a line from the text file");
						}
					}
					temp = br.readLine();
				}
			}catch(Exception e){
				e.printStackTrace();
			}
		}
		return returnable;
	}
	public static void writeFile(String path, String data, boolean overwrite){
		//use bufferedWriter instead? Unsure. Don't think so.
		try{
			File f = new File(path);
			if(f.exists()){
				stdio.debug(new TextLoader(), "File to write exists. "+path);
				if(overwrite){
					stdio.debug(new TextLoader(), "Overwrite, however, is true. File is being overwritten.");
					f.mkdir();
					f.createNewFile();
					FileOutputStream fos = new FileOutputStream(f);
					fos.write(data.getBytes());
					fos.flush();
					fos.close();
				}
			}else{
				f.mkdir();
				f.createNewFile();
				FileOutputStream fos = new FileOutputStream(f);
				fos.write(data.getBytes());
				fos.flush();
				fos.close();
			}
		}catch(Exception ioe){
			ioe.printStackTrace();
		}
	}
}