/*
	This class functions similarly to the TextLoader class except in reverse.
	It will have a writeFile(String[]) method that creates a file (if it does not exist already)
	and throws that String[] into it
*/
package com.ixee.io;

import java.io.*;

public class TextWriter{
	String outputFileName = "";
	File outputFile;
	FileOutputStream outputStream;
	BufferedWriter writer;
	boolean open;

	public TextWriter(String out){
		try{
			outputFileName = out;
			outputFile = new File(out);
			outputFile.createNewFile();
			outputStream = new FileOutputStream(outputFile);
			writer = new BufferedWriter(new OutputStreamWriter(outputStream));
			open = true;
		}catch(IOException ioe){
			open = false;
			stdio.debug(this, "Opening file "+out+" failed somehow?");
			ioe.printStackTrace();
		}
	}
	public void writeLines(String[] toWrite){
		if(open){
			try{
				for(int i=0;i<toWrite.length;i++){
					writer.write(toWrite[i]);
					writer.newLine();
					writer.flush();
				//write;
				}
			}catch(IOException ioe){
				ioe.printStackTrace();
				stdio.debug(this, "Write failed for some reasion: IOException.");
				stdio.log(this, "Write of "+toWrite.length+" lines failed on account of an IOException");
			}
		}else{
			stdio.log(this, "Writer's connection was not open to file: "+outputFileName+", write of "+toWrite.length+" lines was aborted.");
		}
	}
	public void writeLine(String toWrite){
		writeLines(new String[]{toWrite});
	}
	public static void writeFile(String[] text, String output){
		try{
			File out = new File(output);
			//out.mkdirs();
			out.createNewFile();
			BufferedWriter outputWriter = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(out)));
			for(int i=0;i<text.length-1;i++){
				if(text[i] != null){
					outputWriter.write(text[i], 0, text[i].length());
				}
				outputWriter.newLine();
			}
			if(text.length > 0){
				outputWriter.write(text[text.length-1], 0, text[text.length-1].length());
			}
			outputWriter.close();
		}catch(IOException ioe){
			ioe.printStackTrace();
		}
	}
	public void close(){
		try{
			outputStream.flush();
			outputStream.close();
		}catch(IOException ioe){}
		open = false;
	}
}