import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

public class UIButton extends UIActiveElement{
	IxImage image = null;
	IxImage activeImage = null;
	BufferedImage bufImg = null;
	Coordinate bounds;
	public UIButton(Coordinate position, Coordinate b, int mode, String s){
		super(position, mode);
		bounds = b;
		setAppearance(IxImageFactory.makeImage(s, b.intX(), b.intY()));
	}
	public UIButton(Coordinate position, Coordinate b, int mode){
		super(position, mode);
		bounds = b;
	}
	public UIButton(Coordinate position, Coordinate b){
		super(position);
		bounds = b;
		boundMode = -1;
	}
	public void setAppearance(IxImage img){
		image = img;
	}
	public void setActiveAppearance(IxImage img){
		activeImage = img;
	}
	public void testForActive(MouseListen listen){
		Coordinate testPoint = listen.lastLeftClick();
		if(listen.leftClicked() && contains(testPoint)){
			toggleActiveMode = true;
		}
		makeActive();
		//grab cursor info
		//if the cursor is in the bounds of this item,
		//and mouse <appropriate number> is pressed
		//set this to be active
	}
	private boolean contains(Coordinate c){
		boolean returnable = false;
		double leftBound = centerpoint.getX()-bounds.getX()/2;
		double rightBound = centerpoint.getX()+bounds.getX()/2;
		double lowerBound = centerpoint.getY()-bounds.getY()/2;
		double upperBound = centerpoint.getY()+bounds.getY()/2;
		System.out.print("Checking for "+c+" in " + leftBound + " "+rightBound+" "+lowerBound+" "+upperBound+"...");
		if(c.getX() > leftBound && c.getX() < rightBound){
			if(c.getY() > lowerBound && c.getY() < upperBound){
				returnable = true;
			}
		}
		System.out.println(" " + returnable);
		return returnable;
	}
	public void draw(Graphics2D g){
		//g.drawString("STRINGY", centerpoint.intX()-bounds.intX()/2, centerpoint.intY()-bounds.intY()/2);
		if(active && activeImage!=null){
			if(activeImage!=null){
				activeImage.draw(g, centerpoint.intX(), centerpoint.intY());
			}
		}else{
			if(image!=null){
				image.draw(g, centerpoint.intX(), centerpoint.intY());
			}
		}
		//g.drawImage(bufImg, 0, 0, null);
	}
}