package com.ixee.ui.ogl;

import com.ixee.GraphIX.glEEngine;
import com.ixee.datastruct.Coordinate;
import java.awt.Color;

public class UIPoly extends UIElement{
	Coordinate[] vertices;
	Color drawCol;
	boolean fill = false;

	public UIPoly(Coordinate cent, Coordinate[] vert, Color c){
		super(cent);
		setCoords(vert);
		drawCol = c;
	}
	public UIPoly(Coordinate[] vert, Color c){
		super(new Coordinate(0,0,0));
		vertices = vert;
		drawCol = c;
	}
	public void setCenter(Coordinate newCenter){
		for(int i=0;i<vertices.length;i++){
			vertices[i] = vertices[i].sub(centerpoint).add(newCenter);
		}
		centerpoint = newCenter;
	}
	public void setColor(Color c){
		drawCol = c;
	}
	public void setCoords(Coordinate[] newVert){
		vertices = newVert;
		for(int i=0;i<vertices.length;i++){
			vertices[i] = vertices[i].add(centerpoint);
		}
	}
	public void setFill(boolean newFill){
		fill = newFill;
	}
	public void draw(glEEngine e){
		double[] coords = new double[vertices.length*2];
		for(int i=0;i<vertices.length;i++){
			coords[2*i] = vertices[i].getX();
			coords[2*i+1] = vertices[i].getY();
		}
		if(!fill){
			e.drawPoly(coords, drawCol);
		}else{
			e.fillPoly(coords, drawCol);
		}
	}
	public boolean contains(Coordinate c){
		return false;
	}
}